﻿//-----------------------------------------------------------------------
// <copyright file="Flipper.cs" company="Quill18 Productions">
//     Copyright (c) Quill18 Productions. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Flipper : MonoBehaviour 
{
    void Start () 
    {
        theButton = isLeft ? "LeftFlipper" : "RightFlipper";

        hingeJoint = GetComponent<HingeJoint>();
        rigidbody = GetComponent<Rigidbody>();

        JointSpring spring = hingeJoint.spring;
        spring.targetPosition = isLeft ? Angle : -Angle;
        hingeJoint.spring = spring;

        audioSource = GetComponent<AudioSource>();

        AudioListener.volume = 0.25f;
    }

    string theButton;

    bool isOn = false;
    bool setToOn = false;
    public bool isLeft = true;

    HingeJoint hingeJoint;
    Rigidbody rigidbody;

    public float Angle = 20;

    AudioSource audioSource;

    void FixedUpdate () 
    {

        if( setToOn && isOn == false )
        {
            isOn = true;
            rigidbody.WakeUp();
            JointSpring spring = hingeJoint.spring;
            spring.targetPosition = isLeft ? -Angle : Angle;
            hingeJoint.spring = spring;
            audioSource.Play();

            float torque = isLeft ? -Angle : Angle;
            rigidbody.AddTorque( new Vector3(0, torque/100 , 0) );

            rigidbody.WakeUp();
        }

        if( !setToOn && isOn == true )
        {
            isOn = false;
            rigidbody.WakeUp();
            JointSpring spring = hingeJoint.spring;
            spring.targetPosition = isLeft ? Angle : -Angle;
            hingeJoint.spring = spring;
            audioSource.Play();

            float torque = isLeft ? Angle : -Angle;
            rigidbody.AddTorque( new Vector3(0, torque/100 , 0) );

            rigidbody.WakeUp();
        }

    }

    void Update()
    {
        setToOn = Input.GetButton(theButton);
    }
}
