﻿//-----------------------------------------------------------------------
// <copyright file="Kickout.cs" company="Quill18 Productions">
//     Copyright (c) Quill18 Productions. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Kickout : MonoBehaviour 
{
    void Start () 
    {
        collider = GetComponent<Collider>();        
    }

    public float force;
    public float delay;
    float timer = 0;

    Rigidbody ball;

    void Update () 
    {
        timer += Time.deltaTime;

        if(collider.enabled == false)
        {
            // Kick out ball if we have one.
            if(ball != null)
            {
                KickoutBall();
                ball = null;
            }

            if(timer >= 0.25f)
            {
                collider.enabled = true;
            }
        }

        if(ball != null)
        {
            if(timer >= delay)
            {
                KickoutBall();
            }
        }
    }

    void KickoutBall()
    {
        ball.AddForce( this.transform.forward * force );
    }

    Collider collider;

    public GameObject BallPrefab;

    public void SpawnBall(bool updateBallsInPlay = true)
    {
        // Instantiate
        Debug.Log(gameObject.name + " SPAWNING BALL");
        GameObject go = (GameObject)Instantiate(BallPrefab, this.transform.position, Quaternion.identity);

        if(updateBallsInPlay)
            Registry.current.ChangeValue("BallsInPlay", 1);

        timer = 0f;
        collider.enabled = false;

        ball = go.GetComponent<Rigidbody>();
            
    }

    void OnTriggerEnter( Collider col )
    {
        if( col.gameObject.tag == "Player" )
        {
            ball = col.gameObject.GetComponent<Rigidbody>();
            //ball.velocity = Vector3.zero;
            //ball.angularVelocity = Vector3.zero;

            timer = 0;
            Registry.current.BallInScoop[gameObject.name] = col.gameObject;
        }
    }

    void OnTriggerExit( Collider col )
    {
        if(col.gameObject.GetComponent<Rigidbody>() == ball)
        {
            ball = null;
            Registry.current.BallInScoop[gameObject.name] = null;
        }
    }
}
