﻿//-----------------------------------------------------------------------
// <copyright file="NudgeManager.cs" company="Quill18 Productions">
//     Copyright (c) Quill18 Productions. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;
using UnityEngine.UI;

public class NudgeManager : MonoBehaviour 
{
    void Start () 
    {
        tiltText = tiltOverlay.GetComponentInChildren<Text>();
        tiltOverlay.SetActive(false);
    }

    float force = 3f;

    float tiltSensor = 0;

    int warnings = 0;

    public GameObject tiltOverlay;
    Text tiltText;
    float displayTimer = 0;

    void Update () 
    {
        tiltSensor *= (1f - (0.1f * Time.deltaTime));

        if(Input.GetButtonDown("NudgeLeft"))
        {

            GameObject[] balls = GameObject.FindGameObjectsWithTag("Player");

            foreach(GameObject b in balls)
            {
                b.GetComponent<Rigidbody>().AddForce( new Vector3( force, 0, force/2 ) );
            }

            tiltSensor += 1;
            Camera.main.GetComponent<CameraJiggler>().Nudge();
        }
        if(Input.GetButtonDown("NudgeRight"))
        {

            GameObject[] balls = GameObject.FindGameObjectsWithTag("Player");

            foreach(GameObject b in balls)
            {
                b.GetComponent<Rigidbody>().AddForce( new Vector3( -force, 0, force/2 ) );
            }

            tiltSensor += 1;
            Camera.main.GetComponent<CameraJiggler>().Nudge();
        }

        if(tiltSensor > 2)
        {
            warnings++;

            tiltOverlay.SetActive(true);


            if(warnings <= 2)
            {
                tiltText.text = "DANGER" + new string('!', warnings);
                displayTimer = 2f;
            }
            else if(warnings > 2)
            {
                tiltText.text = "TILT!!!!!";
                displayTimer = Mathf.Infinity;
            }

            tiltSensor = 1.99f;
        }

        displayTimer -= Time.deltaTime;
        if(displayTimer < 0)
        {
            tiltOverlay.SetActive(false);
        }

        if(warnings > 2)
        {
            Registry.current.GameOver();
        }

    }
}
