﻿//-----------------------------------------------------------------------
// <copyright file="OnTriggerScorePoints.cs" company="Quill18 Productions">
//     Copyright (c) Quill18 Productions. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class OnTriggerScorePoints : MonoBehaviour 
{
    public int Points = 1000;

    public string PointMultiplierKey = "";

    public float cooldown;
    float lastHit = 0;

    void Update()
    {
        lastHit += Time.deltaTime;
    }

    void OnTriggerEnter( Collider col )
    {
        if(lastHit < cooldown)
        {
            return;
        }

        if(col.gameObject.tag == "Player")
        {
            lastHit = 0;
            Registry.current.AddPoints( 
                Points * Registry.current.GetValue(PointMultiplierKey, 1) 
            );
        }
    }

    void OnCollisionEnter( Collision col )
    {
        OnTriggerEnter( col.collider );
    }
}
