﻿//-----------------------------------------------------------------------
// <copyright file="Plunger.cs" company="Quill18 Productions">
//     Copyright (c) Quill18 Productions. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class Plunger : MonoBehaviour 
{
    void Start () 
    {
        
    }

    float maxForce = 35f;
    float force = 0;
    float timeToMaxForce = 1f;

    float time = 0;
    bool growing = true;

    public float ForcePerc()
    {
        return Mathf.Clamp01(force / maxForce);
    }

    public bool BallPresent()
    {
        return ballInPlungeArea != null;
    }
    
    void Update () 
    {
        if(ballInPlungeArea == null)
        {
            force = 0;
            time = 0;
            growing = true;
            return;
        }

        if( Input.GetButton("Plunge") )
        {
            time += Time.deltaTime;

            if(growing)
            {
                force = Mathf.Lerp(0, maxForce, time / timeToMaxForce);

                if(time >= timeToMaxForce)
                {
                    growing = false;
                    time = 0;
                }
            }
            else
            {
                force = Mathf.Lerp(maxForce, 0, time / timeToMaxForce);

                if(time >= timeToMaxForce)
                {
                    growing = true;
                    time = 0;
                }
            }
        }
        else if (force > 0)
        {
            // Plunger was released
            DoPlunge(ballInPlungeArea.GetComponent<Rigidbody>(), force);
            ballInPlungeArea = null;
            force = 0;
            time = 0;
            growing = true;
        }

    }

    public void DoPlunge(Rigidbody ballRB, float f = -1)
    {
        if(f < 0)
            f = maxForce;
        
        ballRB.GetComponent<Rigidbody>().AddForce( Vector3.forward * f );
    }

    GameObject ballInPlungeArea;

    void OnTriggerEnter(Collider col)
    {
        if(col.gameObject.tag == "Player")
        {
            ballInPlungeArea = col.gameObject;
        }
    }

    void OnTriggerExit(Collider col)
    {
        if(col.gameObject == ballInPlungeArea)
        {
            ballInPlungeArea = null;
        }
    }
}
