﻿//-----------------------------------------------------------------------
// <copyright file="SoundManager.cs" company="Quill18 Productions">
//     Copyright (c) Quill18 Productions. All rights reserved.
// </copyright>
//-----------------------------------------------------------------------

using System.Collections;
using System.Collections.Generic;
using UnityEngine;

public class SoundManager : MonoBehaviour 
{
    void Start () 
    {
        _instance = this;

        queue = new Stack<AudioClip>();
        audioSource = GetComponent<AudioSource>();

        jackpotPlayer = transform.Find("Jackpot").GetComponent<AudioSource>();
    }

    public AudioClip[] chime1k;
    public AudioClip[] chime10k;
    public AudioClip[] jackpots;

    public AudioClip multiball;
    public AudioClip meatball_multiball;
    public AudioClip ball_lock;
    public AudioClip meatpie;
    public AudioClip meatpie_ready;
    public AudioClip salty;
    public AudioClip souper_pops;
    public AudioClip wizard_mode;
    public AudioClip locked;

    Stack<AudioClip> queue;
    AudioSource audioSource;

    void Update () 
    {
        if(audioSource.isPlaying == false)
        {
            if(queue.Count > 0)
            {
                AudioClip clip = queue.Pop();
                audioSource.clip = clip;
                audioSource.Play();
            }
            else {

                if(amountToChime >= 100000)
                {
                    //PlayRandom(chime10k);
                    amountToChime -= 100000;
                    Registry.current.ChangeValue("VisiblePoints", 100000);
                }
                else if(amountToChime >= 10000)
                {
                    PlayRandom(chime10k);
                    amountToChime -= 10000;
                    Registry.current.ChangeValue("VisiblePoints", 10000);
                }
                else if(amountToChime >= 1000)
                {
                    PlayRandom(chime1k);
                    amountToChime -= 1000;
                    Registry.current.ChangeValue("VisiblePoints", 1000);
                }
                else {
                    // no sound
                    Registry.current.ChangeValue("VisiblePoints", amountToChime);
                    amountToChime = 0;
                }
            }
        }
    }

    static public SoundManager _instance;

    AudioSource jackpotPlayer;

    void Jackpot()
    {
        //AudioSource.PlayClipAtPoint( _instance.beeps[ Random.Range(0, _instance.beeps.Length) ] , Camera.main.transform.position );
        /*if( queue.Contains( jackpots[0] ) )
        {
            amountToChime += 20000;
            return;
        }

        PlayRandom( _instance.jackpots );*/

        if(jackpotPlayer.isPlaying == false)
        {
            jackpotPlayer.Play();
        }
    }

    public void Play( AudioClip audio )
    {
        queue.Push(audio);
    }

    void PlayRandom( AudioClip[] array )
    {
        //AudioSource.PlayClipAtPoint( array[ Random.Range(0, array.Length) ] , Camera.main.transform.position );

        queue.Push( array[ Random.Range(0, array.Length) ] );
    }

    int amountToChime = 0;

    public void ScoreChime( int amount )
    {
        if( amount >= 100000 )
        {
            Jackpot();
            //return;
        }

        amountToChime += amount;
    }
}
